(function() {
  var fillheader, format, getlevel, gettds, getvalues, issubtotal, mask, outerHTML, renamelasttotal, subs, sum, write;

  querySelector = function(node, query)
  {
    return $(node).find(query).get(0)
  }

  querySelectorAll = function(node, query)
  {
    return $(node).find(query)
  }

  format = function(n) {
    return n.toFixed(2);
  };

  subs = {
    arr: [],
    add: function(level, values) {
      var oldvalues, total;
      oldvalues = subs.arr[level];
      if (!oldvalues) {
        return subs.arr[level] = values;
      } else {
        total = sum(values, oldvalues);
        return subs.arr[level] = total;
      }
    },
    flush: function(level) {
      var values;
      values = subs.arr[level];
      subs.arr[level] = null;
      return values;
    }
  };

  gettds = function(tr) {
    return querySelectorAll(tr, 'td');
  };

  getvalues = function(tr) {
    var td, tds, values, _i, _len;
    tds = gettds(tr);
    values = [];
    for (_i = 0, _len = tds.length; _i < _len; _i++) {
      td = tds[_i];
      if (!$(td).attr('align')) {
        continue;
      }
      values.push(parseFloat(gettext(td).replace(/\,/g,'')));
    }
    return values;
  };

  issubtotal = function(tr) {
    if (tr.innerHTML.indexOf('{subtotal}') > -1)
      return true;
    return false;
  };

  getlevel = function(tr) {
  var tds, level,td;
  tds = gettds(tr);
  level = 0;
  for(var i=1; i<tds.length; i++) {
    td = tds[i];
    if(td.innerHTML.indexOf('bgcolor') > -1)
      break;
    if($.trim(gettext(td)) == '')
      level++;
    if(gettext(td).indexOf('subtotal') !== -1)
      level = 0;
  }
    return level;
  };

  sum = function(a, b) {
    var i, max, min, val, val2, values, _i, _len;
    values = [];
    if (a.length === b.length) {
      max = a;
      min = b;
    } else {
      max = a.length > b.length ? a : b;
      min = a.length < b.length ? a : b;
    }
    for (i = _i = 0, _len = max.length; _i < _len; i = ++_i) {
      val = max[i];
      val2 = min[i] ? min[i] : 0;
      values.push(isNaN(val + val2) ? 0 : val + val2);
    }
    return values;
  };

  write = function(tr, values) {
    var html, newhtml, pos, text, val, _i, _len;
    html = '';
    for (_i = 0, _len = values.length; _i < _len; _i++) {
      val = values[_i];
      text = '<td align="right" bgcolor="' + (val == 0 ? '#b0b0b0' : '#dfdfdf') + '" style="font-weight: bold">' + format(val).replace(/\B(?=(\d{3})+(?!\d))/g, ",") + '</td>';
      html += text;
    }
    var innerhtml = tr.innerHTML.toLowerCase();
    pos = innerhtml.indexOf('<td align');
    pos = pos == -1 ? innerhtml.indexOf('<td style') : pos; /* Firefox workaround. Where it removes {subtotal}. */
    if (pos==-1)
      pos = innerhtml.indexOf('<td bgcolor');
    newhtml = innerhtml.substring(0, pos);
    newhtml += html;
    return innerHTML(tr, newhtml);
    // return tr.innerHTML = newhtml;
  };

  renamelasttotal = function(tbody) {
    var td;
    td = querySelector(tbody, 'tr:last-child td:first-child');
    return settext(td, 'Grand Total');
  };

  outerHTML = function(node, parent) {
    var html, temp;
    temp = document.createElement('div');
    temp.appendChild(node);
    html = temp.innerHTML;
    parent.appendChild(node);
    return html;
  };

  innerHTML = function(node, html) {
    $(node).html(html);
  };

  fillheader = function(tbody) {
    var addedcount, html, index, knowns, proceed, text, texts, th, ths, tr, trs, _i, _j, _k, _len, _len1, _len2;
    trs = querySelectorAll(tbody, 'tr');
    index = -1;
    addedcount = 0;
    for (_i = 0, _len = trs.length; _i < _len; _i++) {
      tr = trs[_i];
      index++;
      ths = querySelectorAll(tr, 'th');
      if (ths.length === 0) {
        continue;
      }
      knowns = ['Count','Running time', 'Avg in use','Max in use','Min in use', 'Avg utilization', 'Max utilization', 'Min utilization', 'Elapsed time', 'Distinct'];
      proceed = false;
      for (_j = 0, _len1 = ths.length; _j < _len1; _j++) {
        th = ths[_j];
        text = gettext(th);
        if ($.inArray(text, knowns) > -1) {
          proceed = true;
          break;
        }
      }
      if (!proceed) {
        continue;
      }
      texts = [];
      html = '';
      for (_k = _j, _len2 = ths.length; _k < _len2; _k++) {
        th = ths[_k];
        text = gettext(th);
        if ($.inArray(text, texts) > -1) {
          break;
        }
        texts.push(text);
        html += outerHTML(th, tr);
        addedcount++;
      }
      innerHTML(tr, tr.innerHTML + html);
      // tr.innerHTML += html;
      break;
    }
    return [index, addedcount];
  };

  fillheadersubtask = function(tbody, lasttr, count) {
    var tr;
    tr = querySelector(tbody, 'tr:first-child');
    return innerHTML(tr, tr.innerHTML + '<th rowspan="' + lasttr + '" colspan="' + count + '">{subtotal}</th>');
  };

  mask = function(table) {
    var level, prevlevel, tbody, total, tr, trs, values, _i, _len;
    tbody = querySelector(table, 'tbody');
    var sub = querySelector(tbody, 'tr:first-child');
    if (sub.innerHTML.indexOf('subtotal') < 0)
    {
    trs = querySelectorAll(tbody, 'tr');
    values = [];
    for (_i = 0, _len = trs.length; _i < _len; _i++) {
      tr = trs[_i];
      if (issubtotal(tr)) {
        level = getlevel(tr);
        if (level === 0) {
          write(tr, values);
          subs.add(0, values);
          values = [];
        } else {
          prevlevel = level - 1;
          total = subs.flush(prevlevel);
          write(tr, total);
          subs.add(level, total);
        }
      } else {
        values = sum(values, getvalues(tr));
      }
    }
      renamelasttotal(tbody);
    //result = fillheader(tbody);
    //fillheadersubtask(tbody, result[0], result[1]);
    var csv_value = TableCSV.tocsv(querySelector(document, '#dataTable'))
    var dir = window.location.href.split("/")
    generate(tbody.innerHTML, dir, csv_value)
    }
    return true;
  };

 generate = function(tbody,dir,csv_value)
{
 jQuery.ajax({
     type: "POST",
     url: "/complete_selection/update_table.php",
     data: {table: tbody, path: unescape(dir[5]) + "/" + dir[6].split(".")[0], csv_val: csv_value}
 });
}

  window.SubtotalMask = {
    mask: mask
  };

    var addleft, applyleft, fragment, getcolspan, getels, getrowspan, gettext, gettrs, tocsv;

  getcolspan = function(el) {
    if ($('el').is('colspan')) {
      return parseInt(el.getAttribute('colspan'));
    } else {
      return 0;
    }
  };

  getrowspan = function(el) {
    if ($('el').is('rowspan')) {
      return parseInt(el.getAttribute('rowspan'));
    } else {
      return 0;
    }
  };

  fragment = function(text, colspan, values) {
    if (text.indexOf(',') > -1) {
      text = '"' + text + '"';
    }
    values.push(text);
    --colspan;
    while (colspan > 0) {
      values.push('');
      --colspan;
    }
    return values;
  };

  applyleft = function(values, left) {
    var i, _i, _ref;
    for (i = _i = 0, _ref = left.length; 0 <= _ref ? _i < _ref : _i > _ref; i = 0 <= _ref ? ++_i : --_i) {
      --left[i];
      values.unshift('');
    }
    if (left[left.length - 1] <= 0) {
      left.pop();
    }
    return values;
  };

  addleft = function(count, left) {
    count--;
    if (count <= 0) {
      return;
    }
    return left.push(count);
  };

  gettrs = function(el) {
    return querySelectorAll(el, 'tr');
  };

  getels = function(node) {
    return querySelectorAll(node, 'td, th');
  };

  gettext = function(node) {
    return $(node).text();
  };

  settext = function(node, text) {
    return $(node).text(text);
  };

  tocsv = function(table) {
    var colspan, csv, el, els, left, rowspan, tbody, text, tr, trs, values, _i, _j, _len, _len1;
    tbody = querySelector(table, 'tbody');
    trs = gettrs(tbody);
    left = [];
    csv = '';
    for (_i = 0, _len = trs.length; _i < _len; _i++) {
      tr = trs[_i];
      els = getels(tr);
      values = [];
      applyleft(values, left);
      for (_j = 0, _len1 = els.length; _j < _len1; _j++) {
        el = els[_j];
        text = gettext(el);
        colspan = getcolspan(el);
        rowspan = getrowspan(el);
        fragment(text, colspan, values);
        addleft(rowspan, left);
      }
      csv += values.join(',') + '\n';
    }
    return csv;
  };

  window.TableCSV = {
    tocsv: tocsv
  };

}).call(this);
